Index: trunk/kernel/drivers/soclib/soclib_xcu.h
===================================================================
--- trunk/kernel/drivers/soclib/soclib_xcu.h	(revision 1)
+++ trunk/kernel/drivers/soclib/soclib_xcu.h	(revision 1)
@@ -0,0 +1,153 @@
+/*
+ * soclib_xcu.h - soclib XCU driver API definition.
+ *
+ * Alain Greiner    (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _SOCLIB_XCU_H_
+#define _SOCLIB_XCU_H_
+
+#include <hal_types.h>
+#include <device.h>
+
+/******************************************************************************************
+ *    SOCLIB_XCU  Registers Mnemonics
+ *****************************************************************************************/
+
+#define XCU_WTI_REG            0
+#define XCU_PTI_PER            1
+#define XCU_PTI_VAL            2
+#define XCU_PTI_ACK            3
+#define XCU_MSK_PTI            4
+#define XCU_MSK_PTI_ENABLE     5
+#define XCU_MSK_PTI_DISABLE    6
+#define XCU_PTI_ACTIVE         6
+#define XCU_MSK_HWI            8
+#define XCU_MSK_HWI_ENABLE     9
+#define XCU_MSK_HWI_DISABLE    10
+#define XCU_HWI_ACTIVE         10
+#define XCU_MSK_WTI            12
+#define XCU_MSK_WTI_ENABLE     13
+#define XCU_MSK_WTI_DISABLE    14
+#define XCU_WTI_ACTIVE         14
+#define XCU_PRIO               15
+#define XCU_CONFIG             16
+
+/******************************************************************************************
+ * This function initialises the local XCU device masks registers for a given
+ * core identified by its local index.
+ ******************************************************************************************
+ * @ icu       : pointer on the local ICU device descriptor
+ * @ lid       : core local index
+ *****************************************************************************************/
+void soclib_xcu_init( device_t * icu,
+                      lid_t      lid );
+
+/******************************************************************************************
+ * This function set bits in a remote XCU mask register for a given IRQ type,
+ * and a given core. As it uses remote accesses, it can be callet in any cluster.
+ * Only the bits with "1" value in mask argument are set, other bits are not modified.
+ * All input IRQs of requested types corresponding to "1" bits in mask are enabled.
+ ******************************************************************************************
+ * @ icu_xp     : extended pointer on the remote XCU device descriptor.
+ * @ mask       : mask value
+ * @ type       : HWI_TYPE / PTI_TYPE / WTI_TYPE
+ * @ lid        : local core index == output IRQ index
+ *****************************************************************************************/
+void  soclib_xcu_enable_irq( xptr_t     icu_xp,
+                             uint32_t   mask, 
+                             uint32_t   type, 
+                             lid_t      lid );
+
+/******************************************************************************************
+ * This function clear bits in a remote XCU mask register for a given IRQ type,
+ * and a given core. As it uses remote accesses, it can be callet in any cluster.
+ * Only the bits with "1" value in mask argument are cleared, other bits are not modified.
+ * All input IRQs of requested types corresponding to "1" bits in mask are disabled.
+ ******************************************************************************************
+ * @ icu_xp     : extended pointer on the remote XCU device descriptor.
+ * @ mask       : mask value
+ * @ type       : HWI_TYPE / PTI_TYPE / WTI_TYPE
+ * @ lid        : local core index == output IRQ index
+ *****************************************************************************************/
+void  soclib_xcu_disable_irq( xptr_t     icu_xp,
+                              uint32_t   mask, 
+                              uint32_t   type, 
+                              lid_t      lid );
+
+/******************************************************************************************
+ * This function set the period value for a local XCU timer.
+ ******************************************************************************************
+ * @ icu        : pointer on the local ICU device descriptor
+ * @ index      : timer index = PTI index
+ * @ period     : Value to be written 
+ *****************************************************************************************/
+void  soclib_xcu_set_period( device_t * icu,
+                             uint32_t   index,
+                             uint32_t   period );
+
+/******************************************************************************************
+ * This function acknowledge a PTI IRQ for a local XCU timer.
+ ******************************************************************************************
+ * @ icu        : pointer on the local ICU device descriptor
+ * @ index      : timer index = PTI index
+ * @ the returned value in not significant, but acknowledge requires a read.
+ *****************************************************************************************/
+uint32_t soclib_xcu_ack_timer( device_t * icu,
+                               uint32_t   index );
+
+/******************************************************************************************
+ * This function returns the highest priority active interrupt of each type.
+ * If no active interrupt => status == 0 / else => status = index + 1
+ ******************************************************************************************
+ * @ icu        : pointer on the local ICU device descriptor.
+ * @ lid        : core local index.
+ * @ hwi_status : buffer for returned HWI status
+ * @ wti_status : buffer for returned WTI status
+ * @ pti_status : buffer for returned PTI status
+ *****************************************************************************************/
+void  soclib_xcu_get_status( device_t * icu,
+                             lid_t      lid,
+                             uint32_t * hwi_status,
+                             uint32_t * wti_status,
+                             uint32_t * pti_status );
+
+/******************************************************************************************
+ * This function send an IPI (Inter Processor Interrupt) to a remote XCU,
+ * by writing in a WTI mailbox.
+ ******************************************************************************************
+ * @ icu_xp  : extended pointer on target ICU device descriptor.
+ * @ lid     : target core local index == WTI mailbox index.
+ *****************************************************************************************/
+void  soclib_xcu_send_ipi( xptr_t     icu_xp,
+                           lid_t      lid );
+
+/******************************************************************************************
+ * This function returns the local pointer on a WTI mailbox identified by its index.
+ * This function does not access the SOCLIB_XCU hardware device. 
+ ******************************************************************************************
+ * @ icu     : pointer on the local ICU device descriptor.
+ * @ index   : WTI mailbox index.
+ *****************************************************************************************/
+uint32_t * soclib_xcu_wti_ptr( device_t * icu,
+                               uint32_t   index );
+
+
+#endif	/* _SOCLIB_XCU_H_ */
Index: trunk/kernel/fs/devfs/devfs-private.h
===================================================================
--- trunk/kernel/fs/devfs/devfs-private.h	(revision 1)
+++ trunk/kernel/fs/devfs/devfs-private.h	(revision 1)
@@ -0,0 +1,47 @@
+/*
+ * devfs/devfs-private.h - devfs internal functions and data types
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DEVFS_PRIVATE_H_
+#define _DEVFS_PRIVATE_H_
+
+#include <spinlock.h>
+#include <metafs.h>
+
+struct devfs_db_s
+{
+	spinlock_t lock;
+	struct metafs_s root;
+};
+
+extern struct devfs_db_s devfs_db;
+
+struct devfs_file_s
+{
+	struct metafs_iter_s iter;
+	struct device_s *dev;
+	struct devfs_context_s *ctx;
+};
+
+const struct vfs_inode_op_s devfs_i_op;
+const struct vfs_file_op_s devfs_f_op;
+
+#endif	/* _DEVFS_PRIVATE_H_ */
Index: trunk/kernel/fs/devfs/devfs.h
===================================================================
--- trunk/kernel/fs/devfs/devfs.h	(revision 1)
+++ trunk/kernel/fs/devfs/devfs.h	(revision 1)
@@ -0,0 +1,53 @@
+/*
+ * devfs.h - export devfs memory and context related operations
+ *
+ * Author     Ghassan Almaless (2008,2009,2010,2011,2012)
+ *            Mohamed Lamine Karaoui (2015)
+ *            Alain Greiner (2017)
+ *
+ * Copyright (c) Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _DEVFS_H_
+#define _DEVFS_H_
+
+#include <metafs.h>
+#include <device.h>
+
+/******************************************************************************************
+ * This structure TODO
+ *****************************************************************************************/
+
+typedef struct devfs_context_s
+{
+	struct metafs_s * db;
+}
+devfs_context_t;
+
+/******************************************************************************************
+ * This function TODO
+ *****************************************************************************************/
+void devfs_root_init();
+
+/******************************************************************************************
+ * This function TODO
+ *****************************************************************************************/
+void devfs_register( device_t * dev );
+
+
+#endif	/* _DEVFS_H_ */
Index: trunk/kernel/fs/devfs/devfs_context.c
===================================================================
--- trunk/kernel/fs/devfs/devfs_context.c	(revision 1)
+++ trunk/kernel/fs/devfs/devfs_context.c	(revision 1)
@@ -0,0 +1,116 @@
+/*
+ * devfs/devfs_context.c - devfs context related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <device.h>
+#include <driver.h>
+#include <kmem.h>
+#include <string.h>
+#include <vfs.h>
+#include <errno.h>
+#include <metafs.h>
+#include <cpu.h>
+
+#include <devfs.h>
+#include <devfs-private.h>
+
+
+struct devfs_db_s devfs_db;
+
+void devfs_root_init(void)
+{
+	spinlock_init(&devfs_db.lock, "DevFs DB");
+
+	metafs_init(&devfs_db.root, 
+#if CONFIG_ROOTFS_IS_VFAT
+		    "DEV"
+#else
+		    "dev"
+#endif
+		);
+}
+
+void devfs_register(struct device_s *dev)
+{
+	spinlock_lock(&devfs_db.lock);
+	metafs_register(&devfs_db.root, &dev->node);
+	spinlock_unlock(&devfs_db.lock);
+}
+
+
+VFS_CREATE_CONTEXT(devfs_create_context)
+{
+	struct devfs_context_s *ctx;
+  
+	VFS_SET(context->ctx_flags, VFS_FS_LOCAL);
+	context->ctx_type    = FS_TYPE_DEVFS;
+	context->ctx_op      = (struct vfs_context_op_s *) &devfs_ctx_op;
+	context->ctx_inode_op = (struct vfs_inode_op_s *) &devfs_i_op;
+	context->ctx_file_op = (struct vfs_file_op_s *) &devfs_f_op;
+
+	ctx	= &context->ctx_devfs;
+	ctx->db = &devfs_db.root;
+
+	return 0;
+}
+
+VFS_DESTROY_CONTEXT(devfs_destroy_context)
+{
+	return 0;
+}
+
+VFS_READ_ROOT(devfs_read_root)
+{ 
+	root->i_links = 1;
+	root->i_size  = 0;
+	root->i_attr  = VFS_DIR;
+	root->i_number = vfs_inum_new(context);
+  
+	return 0;
+}
+
+VFS_WRITE_ROOT(devfs_write_root)
+{
+	return 0;
+}
+
+KMEM_OBJATTR_INIT(devfs_kmem_context_init)
+{
+	attr->type   = KMEM_DEVFS_CTX;
+	attr->name   = "KCM DevFs CTX";
+	attr->size   = sizeof(struct devfs_context_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_DEVFS_CTX_MIN;
+	attr->max    = CONFIG_DEVFS_CTX_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+	return 0;
+}
+
+
+const struct vfs_context_op_s devfs_ctx_op = 
+{
+	.create     = devfs_create_context,
+	.destroy    = devfs_destroy_context,
+	.read_root  = devfs_read_root,
+	.repli_root = NULL,
+	.write_root = devfs_write_root
+};
Index: trunk/kernel/fs/devfs/devfs_file.c
===================================================================
--- trunk/kernel/fs/devfs/devfs_file.c	(revision 1)
+++ trunk/kernel/fs/devfs/devfs_file.c	(revision 1)
@@ -0,0 +1,271 @@
+/*
+ * devfs/devfs_file.c - devfs file related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <device.h>
+#include <driver.h>
+#include <kmem.h>
+#include <string.h>
+#include <vfs.h>
+#include <errno.h>
+#include <metafs.h>
+#include <thread.h>
+
+#include <devfs.h>
+#include <devfs-private.h>
+
+
+KMEM_OBJATTR_INIT(devfs_kmem_file_init)
+{
+	attr->type   = KMEM_DEVFS_FILE;
+	attr->name   = "KCM DevFs File";
+	attr->size   = sizeof(struct devfs_file_s);
+	attr->aligne = 0;
+	attr->min    = CONFIG_DEVFS_FILE_MIN;
+	attr->max    = CONFIG_DEVFS_FILE_MAX;
+	attr->ctor   = NULL;
+	attr->dtor   = NULL;
+	return 0;
+}
+
+VFS_OPEN_FILE(devfs_open)
+{
+	register error_t err;
+	register struct devfs_context_s *ctx;
+	register struct devfs_file_s *info;
+	register struct device_s *dev;
+	struct vfs_inode_s *inode;
+	dev_request_t rq;
+	kmem_req_t req;
+
+	inode = file->fr_inode;
+
+	info = file->fr_pv;
+	ctx  = (struct devfs_context_s *)&inode->i_ctx->ctx_devfs;
+
+	if(!(inode->i_attr & VFS_DIR))
+	{
+		dev = (struct device_s*)inode->i_pv;
+    
+		if(dev->type == DEV_INTERNAL)
+			return EPERM;
+
+		if(dev->type == DEV_BLK)
+			VFS_SET(inode->i_attr,VFS_DEV_BLK);
+		else
+			VFS_SET(inode->i_attr,VFS_DEV_CHR);
+ 
+		if(dev->op.dev.open != NULL)
+		{
+			rq.fremote = file;
+			if((err=dev->op.dev.open(dev, &rq)))
+				return err;
+		}
+
+		priv->dev = (void*)dev;
+
+		return 0;
+	}
+
+	if(info == NULL)
+	{
+		req.type  = KMEM_DEVFS_FILE;
+		req.size  = sizeof(*info);
+		req.flags = AF_KERNEL;
+		info      = kmem_alloc(&req);
+	}
+
+	if(info == NULL) return ENOMEM;
+
+	metafs_iter_init(&devfs_db.root, &info->iter);
+	info->ctx  = ctx;
+	file->fr_pv = info;
+  
+	metafs_print(&devfs_db.root);
+	return 0;
+}
+
+#define TMP_BUFF_SZ 512
+//FIXME:
+//add a "while" loop for the case where the
+//buffer TMP_BUFF_SZ is smaller than
+//buffer->size
+VFS_READ_FILE(devfs_read)
+{
+	register struct device_s *dev;
+	dev_request_t rq;
+	uint_t count;
+        uint8_t buff[TMP_BUFF_SZ];
+
+	dev = (struct device_s*)file->f_private.dev;
+
+	rq.dst   = &buff[0];
+	rq.count = TMP_BUFF_SZ;
+	rq.flags = 0;
+	rq.file  = file;
+
+	if((count = dev->op.dev.read(dev, &rq)) < 0)
+		return count;
+
+        buffer->scpy_to_buff(buffer, &buff[0], count);
+	return count;
+}
+
+//FIXME: To improve this an avoid the extra copy,
+//we could set along with the buffer(src and dest) 
+//the functions to manipulate them, such as in 
+//do_exec.c
+VFS_WRITE_FILE(devfs_write)
+{
+	register struct device_s *dev;
+	uint8_t buff[TMP_BUFF_SZ];
+	dev_request_t rq;
+	
+	dev = (struct device_s*)file->f_private.dev;
+	
+	//FIXME avoid the extra copy ?
+	buffer->scpy_from_buff(buffer, (void*)&buff[0], TMP_BUFF_SZ);
+	rq.src   = (void*)&buff[0];
+	rq.count = buffer->size;
+	rq.flags = 0;
+	rq.file  = file;
+  
+	return dev->op.dev.write(dev, &rq);
+}
+
+VFS_LSEEK_FILE(devfs_lseek)
+{
+	register struct device_s *dev;
+	dev_request_t rq;
+
+	dev = (struct device_s*)file->fr_inode->i_pv;
+
+	if(dev->op.dev.lseek == NULL)
+		return VFS_ENOTUSED;
+  
+	rq.fremote = file;
+	return dev->op.dev.lseek(dev, &rq);
+}
+
+VFS_CLOSE_FILE(devfs_close)
+{
+	register struct device_s *dev;
+	dev_request_t rq;
+
+	if(file->fr_inode->i_attr & VFS_DIR)
+		return 0;
+
+	dev = (struct device_s*)file->fr_inode->i_pv;
+
+	if(dev->op.dev.close == NULL)
+		return 0;
+  
+	rq.fremote = file;
+	return dev->op.dev.close(dev, &rq);
+}
+
+VFS_RELEASE_FILE(devfs_release)
+{  
+	kmem_req_t req;
+
+	if(file->fr_pv == NULL) 
+		return 0;
+  
+	req.type = KMEM_DEVFS_FILE;
+	req.ptr  = file->fr_pv;
+	kmem_free(&req);
+
+	file->fr_pv = NULL;
+	return 0;
+}
+
+VFS_READ_DIR(devfs_readdir)
+{
+	register struct devfs_file_s *info;
+	register struct metafs_s *current;
+	register struct device_s *current_dev;
+  
+	info = file->fr_pv;
+  
+	if(file->fr_pv == NULL)
+		return ENOTDIR;
+
+	if((current = metafs_lookup_next(&devfs_db.root, &info->iter)) == NULL)
+		return EEODIR;
+
+	current_dev    = metafs_container(current, struct device_s, node);
+	dirent->u_attr = (current_dev->type == DEV_BLK) ? VFS_DEV_BLK : VFS_DEV_CHR;
+
+	strcpy((char*)dirent->u_name, metafs_get_name(current));
+
+	dirent->u_ino = (uint_t) current_dev->base_paddr;
+
+	return 0;
+}
+
+VFS_MMAP_FILE(devfs_mmap)
+{
+	register struct device_s *dev;
+	dev_request_t rq;
+  
+	dev = (struct device_s*)file->f_private.dev;
+
+	if(dev->op.dev.mmap == NULL)
+		return ENODEV;
+
+	rq.flags  = 0;
+	rq.file   = file;
+	rq.region = region;
+
+	return dev->op.dev.mmap(dev, &rq);
+}
+
+VFS_MMAP_FILE(devfs_munmap)
+{
+	register struct device_s *dev;
+	dev_request_t rq;
+
+	dev = (struct device_s*)file->f_private.dev;
+
+	if(dev->op.dev.munmap == NULL)
+		return ENODEV;
+
+	rq.flags  = 0;
+	rq.file   = file;
+	rq.region = region;
+
+	return dev->op.dev.munmap(dev, &rq);
+}
+
+
+const struct vfs_file_op_s devfs_f_op = 
+{
+	.open    = devfs_open,
+	.read    = devfs_read,
+	.write   = devfs_write,
+	.lseek   = devfs_lseek,
+	.mmap    = devfs_mmap,
+	.munmap  = devfs_munmap,
+	.readdir = devfs_readdir,
+	.close   = devfs_close,
+	.release = devfs_release
+};
Index: trunk/kernel/fs/devfs/devfs_node.c
===================================================================
--- trunk/kernel/fs/devfs/devfs_node.c	(revision 1)
+++ trunk/kernel/fs/devfs/devfs_node.c	(revision 1)
@@ -0,0 +1,187 @@
+/*
+ * devfs/devfs_node.c - devfs node related operations
+ *
+ * Copyright (c) 2008,2009,2010,2011,2012 Ghassan Almaless
+ * Copyright (c) 2011,2012 UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-kernel.
+ *
+ * ALMOS-kernel is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-kernel is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-kernel; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <config.h>
+#include <kmem.h>
+#include <string.h>
+#include <kdmsg.h>
+#include <device.h>
+#include <vfs.h>
+#include <cpu.h>
+
+#include <devfs.h>
+#include <devfs-private.h>
+
+
+
+VFS_INIT_NODE(devfs_init_node)
+{
+	inode->i_pv     = NULL;
+	return 0;
+}
+
+
+VFS_RELEASE_NODE(devfs_release_node)
+{
+	inode->i_pv = NULL;
+	return 0;
+}
+
+
+VFS_CREATE_NODE(devfs_create_node)
+{ 
+	return ENOTSUPPORTED;
+}
+
+error_t devfs_inode_create(struct vfs_dirent_s *dirent, 
+				struct vfs_inode_s *parent,
+				struct device_s *dev, size_t size)
+{
+	struct vfs_inode_s *inode;
+
+	inode = vfs_inode_new(dirent->d_ctx);//allocate inode
+	if(!inode) return ENOMEM;
+
+	inode->i_links  = 1;
+	inode->i_attr = dirent->d_attr;
+	inode->i_pv = (struct device_s*) dev;
+	inode->i_size = size;
+	inode->i_parent.ptr = parent;
+	inode->i_parent.cid = cpu_get_cid();
+	inode->i_parent.gc = parent->i_gc;
+	inode->i_number = vfs_inum_new(dirent->d_ctx);
+
+	vfs_icache_add(inode);
+
+	VFS_INODE_REF_SET(dirent->d_inode, inode, cpu_get_cid());
+
+	return 0;
+}
+
+VFS_LOOKUP_NODE(devfs_lookup_node)
+{
+	register struct metafs_s *meta_node;
+	register struct device_s *dev;
+	register error_t err;
+	dev_params_t params;
+
+	if(!(parent->i_attr & VFS_DIR))
+		return ENOTDIR;
+  
+
+	if((meta_node = metafs_lookup(&devfs_db.root, dirent->d_name)) == NULL)
+		return VFS_NOT_FOUND;
+
+	dev = metafs_container(meta_node, struct device_s, node);
+  
+	if((err=dev->op.dev.get_params(dev, &params)))
+	{
+		printk(ERROR,"ERROR: devfs_lookup_node: error %d while getting device parameters\n", err);
+		return err;
+	}
+  
+	switch(dev->type)
+	{
+	case DEV_BLK:
+		dirent->d_attr |= VFS_DEV_BLK;
+		break;
+	case DEV_CHR:
+		dirent->d_attr |= VFS_DEV_CHR;
+		break;
+	default:
+		dirent->d_attr |= VFS_DEV;
+	}
+
+	//Do a list of inode within the device struct to avoid 
+	//creating each time a new inode.
+	devfs_inode_create(dirent, parent, dev, params.size);
+
+	return VFS_FOUND;
+}
+
+VFS_STAT_NODE(devfs_stat_node)
+{
+	struct device_s *dev;
+	uint_t mode;
+
+	dev       = (struct device_s*)inode->i_pv;
+	mode      = 0;
+
+	inode->i_stat.st_dev     = (uint_t)dev;
+	inode->i_stat.st_ino     = (uint_t)dev;
+	inode->i_stat.st_nlink   = inode->i_links;
+	inode->i_stat.st_uid     = 0;
+	inode->i_stat.st_gid     = 0;
+	inode->i_stat.st_rdev    = FS_TYPE_DEVFS;
+	inode->i_stat.st_size    = inode->i_size;
+	inode->i_stat.st_blksize = 0;
+	inode->i_stat.st_blocks  = 0;
+	inode->i_stat.st_atime   = 0;
+	inode->i_stat.st_mtime   = 0;
+	inode->i_stat.st_ctime   = 0;
+
+	if(inode->i_attr & VFS_DIR)
+	{
+		VFS_SET(mode, VFS_IFDIR);
+	}
+	else if(inode->i_attr & VFS_FIFO)
+	{
+		VFS_SET(mode, VFS_IFIFO);
+	}
+	else if(inode->i_attr & VFS_PIPE)
+	{
+		VFS_SET(mode, VFS_IFIFO);
+	}
+	else if(inode->i_attr & VFS_DEV_CHR)
+	{
+		VFS_SET(mode, VFS_IFCHR);
+	}
+	else if(inode->i_attr & VFS_DEV_BLK)
+	{
+		VFS_SET(mode, VFS_IFBLK);
+	}
+ 
+	inode->i_stat.st_mode = mode;
+	return 0;
+}
+
+
+VFS_WRITE_NODE(devfs_write_node)
+{
+	return 0;
+}
+
+VFS_UNLINK_NODE(devfs_unlink_node)
+{
+	return ENOTSUPPORTED;
+}
+
+const struct vfs_inode_op_s devfs_i_op = 
+{
+	.init    = devfs_init_node,
+	.create  = devfs_create_node,
+	.lookup  = devfs_lookup_node,
+	.write   = devfs_write_node,
+	.release = devfs_release_node,
+	.unlink  = devfs_unlink_node,
+	.stat    = devfs_stat_node
+};
